#!/usr/bin/env node


'use strict';

var _internalIp = require('internal-ip');

var _internalIp2 = _interopRequireDefault(_internalIp);

var _clor = require('clor');

var _clor2 = _interopRequireDefault(_clor);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _package = require('../package');

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var argv = _yargs2.default.usage('Usage: $0 [options]').option('uiPort', {
  describe: 'Port you want the UI to listen to. Defaults to 80'
}).option('dataDir', {
  describe: "Top directory you want Homie's data to be stored in. Defaults to <homeDir>/.homie"
}).option('logLevel', {
  describe: 'Minimum log level for console output'
}).help().locale('en').argv;

var homieStyled = _clor2.default.magenta('  _ _              _\n | | | ___ ._ _ _ <_> ___\n |   |/ . \\| \' \' || |/ ._>\n |_|_|\\___/|_|_|_||_|\\___.\n').toString();

console.log(homieStyled);
console.log(_clor2.default.magenta('Version ').bold.magenta(_package2.default.version).line());

console.log(_clor2.default.magenta('See ').underline.magenta('https://git.io/homie-server#configuration').line());

console.log(_clor2.default.magenta('Homie server IP is ').bold.underline.magenta(_internalIp2.default.v4())());
console.log(_clor2.default.magenta("Make sure this IP won't change over time").line());

(0, _index2.default)({
  uiPort: argv.uiPort,
  dataDir: argv.dataDir,
  logLevel: argv.logLevel
});