'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SET_NODE_PROPERTY = exports.NODE_PROPERTY = exports.DEVICE_PROPERTY = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEVICE_PROPERTY = exports.DEVICE_PROPERTY = 'DEVICE_PROPERTY';
var NODE_PROPERTY = exports.NODE_PROPERTY = 'NODE_PROPERTY';
var SET_NODE_PROPERTY = exports.SET_NODE_PROPERTY = 'SET_NODE_PROPERTY';

var MqttParser = function () {
  function MqttParser() {
    (0, _classCallCheck3.default)(this, MqttParser);
  }

  (0, _createClass3.default)(MqttParser, [{
    key: 'parse',
    value: function parse(topic, message) {
      var path = topic.split('/');

      // Must start with devices

      if (path[0] !== 'devices') {
        return false;
      }

      /*
      valid messages:
      - devices/testdevice/$fwname
      - devices/testdevice/node/property
      - devices/testdevice/node/property/set
      */

      if (path.length < 3 || path.length > 5) {
        return false;
      }

      // Check if deviceId only [a-z0-9\-]
      for (var i = 0; i < path[1].length; i++) {
        if (!(path[1][i] >= 'a' && path[1][i] <= 'z' || path[1][i] >= '0' && path[1][i] <= '9' || path[1][i] === '-')) {
          return false;
        }
      }
      // Check if deviceId doesn't start or end with '-'
      if (path[1][0] === '-' || path[1][path[1].length - 1] === '-') {
        return false;
      }

      // Device property

      if (path.length === 3) {
        if (!path[2].startsWith('$')) {
          return false;
        }

        return {
          type: DEVICE_PROPERTY,
          deviceId: path[1],
          property: {
            name: path[2].substring(1),
            value: message
          }
        };
      } else if (path.length === 4) {
        if (path[2].startsWith('$') || path[3].startsWith('$') || path[3] === 'set') {
          return false;
        }

        return {
          type: NODE_PROPERTY,
          deviceId: path[1],
          nodeId: path[2],
          property: {
            name: path[3],
            value: message
          }
        };
      } else if (path.length === 5) {
        if (path[4] !== 'set') {
          return false;
        }

        return {
          type: SET_NODE_PROPERTY,
          deviceId: path[1],
          nodeId: path[2],
          property: {
            name: path[3],
            value: message
          }
        };
      }
    }
  }]);
  return MqttParser;
}();

exports.default = new MqttParser();