'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _bluebird = require('bluebird');

var _isMyJsonValid = require('is-my-json-valid');

var _isMyJsonValid2 = _interopRequireDefault(_isMyJsonValid);

var _property = require('./property');

var _property2 = _interopRequireDefault(_property);

var _log = require('../log');

var _log2 = _interopRequireDefault(_log);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = _bluebird.Promise.promisifyAll(require('fs'));

var DataDirValidator = function () {
  function DataDirValidator() {
    (0, _classCallCheck3.default)(this, DataDirValidator);
  }

  (0, _createClass3.default)(DataDirValidator, [{
    key: 'validateOtaManifest',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(object, dataDir) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', new _bluebird.Promise(function (resolve) {
                  var validate = (0, _isMyJsonValid2.default)({
                    required: true,
                    type: 'object',
                    additionalProperties: false,
                    properties: {
                      firmwares: {
                        required: true,
                        type: 'array',
                        items: {
                          type: 'object',
                          additionalProperties: false,
                          properties: {
                            name: {
                              required: true,
                              type: 'string'
                            },
                            version: {
                              required: true,
                              type: 'string'
                            },
                            devices: {
                              required: true,
                              type: 'array',
                              items: {
                                type: 'string'
                              }
                            }
                          }
                        }
                      }
                    }
                  });

                  if (!validate(object)) {
                    _log2.default.error('OTA manifest invalid');
                    return resolve(false);
                  }

                  // Check if a device is referenced multiple times

                  var deviceIds = object.firmwares.map(function (device) {
                    return device.id;
                  });

                  if (new _set2.default(deviceIds).size !== deviceIds.length) {
                    _log2.default.error('OTA manifest references multiple firmwares for a single device');
                    return resolve(false);
                  }

                  if (!dataDir) {
                    return resolve(true);
                  }
                  // Check if all firmware binaries exist

                  var errors = false;
                  object.firmwares.forEach(function () {
                    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(firmware, index) {
                      return _regenerator2.default.wrap(function _callee$(_context) {
                        while (1) {
                          switch (_context.prev = _context.next) {
                            case 0:
                              _context.prev = 0;
                              _context.next = 3;
                              return fs.accessAsync(dataDir + '/ota/firmwares/' + firmware.name + '.bin', fs.F_OK);

                            case 3:
                              _context.next = 9;
                              break;

                            case 5:
                              _context.prev = 5;
                              _context.t0 = _context['catch'](0);

                              _log2.default.error('Cannot find firmware ' + dataDir + '/ota/firmwares/' + firmware.name + '.bin');
                              errors = true;

                            case 9:

                              if (index === object.firmwares.length - 1) {
                                if (errors) {
                                  resolve(false);
                                }

                                resolve(true);
                              }

                            case 10:
                            case 'end':
                              return _context.stop();
                          }
                        }
                      }, _callee, this, [[0, 5]]);
                    }));
                    return function (_x3, _x4) {
                      return ref.apply(this, arguments);
                    };
                  }());
                }));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
      return function validateOtaManifest(_x, _x2) {
        return ref.apply(this, arguments);
      };
    }()
  }, {
    key: 'validateInfrastructure',
    value: function validateInfrastructure(object) {
      var validate = (0, _isMyJsonValid2.default)({
        required: true,
        type: 'object',
        additionalProperties: false,
        properties: {
          devices: {
            required: true,
            type: 'array',
            items: {
              type: 'object',
              additionalProperties: false,
              properties: {
                id: {
                  required: true,
                  type: 'string'
                },
                location: {
                  required: true,
                  type: 'string'
                },
                color: {
                  required: false,
                  type: 'string'
                },
                nodes: {
                  required: true,
                  type: 'array',
                  minItems: 1,
                  items: {
                    type: 'object',
                    additionalProperties: false,
                    properties: {
                      type: {
                        required: true,
                        type: 'string'
                      },
                      id: {
                        required: true,
                        type: 'string'
                      },
                      name: {
                        required: true,
                        type: 'string'
                      },
                      color: {
                        required: false,
                        type: 'string'
                      }
                    }
                  }
                }
              }
            }
          },
          groups: {
            required: true,
            type: 'array',
            items: {
              type: 'object',
              additionalProperties: false,
              properties: {
                id: {
                  required: true,
                  type: 'string'
                },
                name: {
                  required: true,
                  type: 'string'
                },
                color: {
                  required: false,
                  type: 'string'
                },
                devices: {
                  required: true,
                  type: 'array',
                  items: {
                    type: 'string'
                  }
                }
              }
            }
          }
        }
      });

      if (!validate(object)) {
        _log2.default.error('infrastructure.yml invalid');
        return false;
      }

      // Check if there are no duplicates device ids
      var deviceIds = object.devices.map(function (device) {
        return device.id;
      });

      if (new _set2.default(deviceIds).size !== deviceIds.length) {
        _log2.default.error('infrastructure.yml contains duplicate devices');
        return false;
      }

      // Check if there are no duplicates node ids
      var duplicateNodes = false;
      object.devices.forEach(function (device) {
        // Check if there are no duplicates device ids
        var nodeIds = device.nodes.map(function (node) {
          return node.id;
        });

        if (new _set2.default(nodeIds).size !== nodeIds.length) {
          duplicateNodes = true;
        }
      });

      if (duplicateNodes) {
        _log2.default.error('infrastructure.yml contains duplicate nodes');
        return false;
      }

      // Check if there are no duplicates group ids
      var groupsIds = object.groups.map(function (group) {
        return group.id;
      });

      if (new _set2.default(groupsIds).size !== groupsIds.length) {
        _log2.default.error('infrastructure.yml contains duplicate groups');
        return false;
      }

      // Check if all devices in group exist
      var devicesExist = true;
      object.groups.forEach(function (group) {
        group.devices.forEach(function (deviceId) {
          if (deviceIds.indexOf(deviceId) <= -1) {
            devicesExist = false;
          }
        });
      });

      if (!devicesExist) {
        _log2.default.error('infrastructure.yml groups reference non-existent devices');
        return false;
      }

      // Check if all node types are valid
      var nodeTypesValid = true;
      object.devices.forEach(function (device) {
        device.nodes.forEach(function (node) {
          if (!_property2.default.typeExists(node.type)) {
            nodeTypesValid = false;
          }
        });
      });

      if (!nodeTypesValid) {
        _log2.default.error('infrastructure.yml contains invalid node types');
        return false;
      }

      return true;
    }
  }, {
    key: 'validateConfig',
    value: function validateConfig(object) {
      var validate = (0, _isMyJsonValid2.default)({
        required: true,
        type: 'object',
        additionalProperties: false,
        properties: {
          mqtt: {
            required: true,
            type: 'object',
            additionalProperties: false,
            properties: {
              url: {
                required: true,
                type: 'string'
              },
              username: {
                required: false,
                type: 'string'
              },
              password: {
                required: false,
                type: 'string'
              },
              clientId: {
                required: false,
                type: 'string'
              }
            }
          }
        }
      });

      if (!validate(object)) {
        _log2.default.error('config.yml invalid');
        return false;
      }

      return true;
    }
  }]);
  return DataDirValidator;
}();

exports.default = new DataDirValidator();